/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>
#include <cstdlib>
#include <iostream>
#include "calculo.h"
#include "reloj.h"

using namespace std;

calculo::calculo() {
    srand(time(0));
}

void calculo::dibujarescenarioari(SDL_Surface* pantalla){
    //Cargamos la imagen de fondo
    SDL_Surface* bmp = IMG_Load("../imagenes/fondos/aritmetica.png");
    if (!bmp)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_BlitSurface(bmp,0,pantalla,0);
    SDL_Surface* boton1 = IMG_Load("../imagenes/botones/Salir.png");
     if(!boton1)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Rect rectbtn;
    rectbtn.x=630;
    rectbtn.y=20;
    SDL_BlitSurface(boton1, 0, pantalla, &rectbtn);
}
Uint32 calculo::generarcuenta(SDL_Surface* pantalla){
    Uint32 num1, num2, operador;
    int w,h;
    char cadena[30];
     //Cargamos los tipos de letras
    TTF_Font *fuente;
    fuente = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 40);
    if(!fuente)
    {
        cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
        exit(1);
    }
    //Cargamos el numero a recordar
    SDL_Surface *texto;
    SDL_Color color;
    SDL_Rect dest;
    // Establecemos el color para la fuente
    color.r = 0;
    color.g = 0;
    color.b = 0;

    num1=1+rand()%9;
    num2=1+rand()%9;
    operador=rand()%4;
    switch(operador){
        case 0: {
            sprintf(cadena,"%d  +  ?  =  %d",num1,num1+num2);
            TTF_SizeUTF8(fuente, cadena, &w, &h);
            texto = TTF_RenderText_Blended(fuente, cadena, color);
        }
        break;
        case 1:{
            sprintf(cadena,"%d  -  ?  =  %d",num1,num1-num2);
            TTF_SizeUTF8(fuente, cadena, &w, &h);
            texto = TTF_RenderText_Blended(fuente, cadena, color);
        }
        break;
        case 2:{
            sprintf(cadena,"%d  x  ?  =  %d",num1,num1*num2);
            TTF_SizeUTF8(fuente, cadena, &w, &h);
            texto = TTF_RenderText_Blended(fuente, cadena, color);
        }
        break;
        case 3:{
            while(num1%num2!=0)
                num2=1+rand()%9;
            cout<<"Num2: "<<num2<<endl;
            sprintf(cadena,"%d  :  ?  =  %d",num1,num1/num2);
            TTF_SizeUTF8(fuente, cadena, &w, &h);
            texto = TTF_RenderText_Blended(fuente, cadena, color);
        }
        break;
        default:
            cout<<"Operador Incorrecto"<<endl;
            exit(1);
    }
    dest.x=400-w/2;
    dest.y=300-h/2;
    SDL_BlitSurface(texto,0,pantalla,&dest);
    return num2;
}

Uint32 calculo::aritmetica(SDL_Surface* pantalla){
    bool done=false;
    Uint32 resultado, nivel=1, tiempo;
    SDL_Rect recttiempo;
    recttiempo.x=700;
    recttiempo.y=550;
    recttiempo.h=50;
    recttiempo.w=100;
    reloj crono(90, 730, 555);
    dibujarescenarioari(pantalla);
    resultado=generarcuenta(pantalla);
     while (!done)
    {
        // Manejo de eventos
        SDL_Event event;
        while(SDL_PollEvent(&event)){
        	//tecl.actualizar();
       		if(event.type==SDL_QUIT){
                    return 0;
       		 }
                if(event.type==SDL_MOUSEBUTTONDOWN)
                {
                    Uint32 mousex, mousey;
                    mousex=event.button.x;
                    mousey=event.button.y;
                    //Comprobacion btn modo arcade
                    if(mousex>630&&mousey>20&&mousex<(630+150)&&mousey<(20+40)){
                        cout<<"Pulsacion de boton: Salir"<<endl;
                        return 0;
                    }
                }
                if(event.type==SDL_KEYDOWN)
                {
                    switch(event.key.keysym.sym){
                        case SDLK_1:{
                            if(resultado==1){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_KP1:{
                            if(resultado==1){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_2:{
                            if(resultado==2){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_KP2:{
                            if(resultado==2){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_3:{
                            if(resultado==3){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_KP3:{
                            if(resultado==3){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_4:{
                            if(resultado==4){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_KP4:{
                            if(resultado==4){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_5:{
                            if(resultado==5){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_KP5:{
                            if(resultado==5){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_6:{
                            if(resultado==6){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_KP6:{
                            if(resultado==6){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_7:{
                            if(resultado==7){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_KP7:{
                            if(resultado==7){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_8:{
                            if(resultado==8){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_KP8:{
                            if(resultado==8){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_9:{
                            if(resultado==9){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_KP9:{
                            if(resultado==9){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_0:{
                            if(resultado==0){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_KP0:{
                            if(resultado==0){
                                nivel++;
                                dibujarescenarioari(pantalla);
                                resultado=generarcuenta(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        default:
                            cout<<"Tecla Incorrecta"<<endl;
                    }
                }
        }
        if(SDL_GetTicks()-tiempo>1000){
            SDL_FillRect(pantalla, &recttiempo, SDL_MapRGB(pantalla->format,162,162,160));
            crono.actualizartiempo(pantalla);
            tiempo=SDL_GetTicks();
        }
        if(crono.consultarseg()==0){
            done=true;
        }
        SDL_Flip(pantalla);
     }
    return nivel;
}

void calculo::dibujarescenarioope(SDL_Surface* pantalla){
        //Cargamos la imagen de fondo
    SDL_Surface* bmp = IMG_Load("../imagenes/fondos/operadores.png");
    if (!bmp)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_BlitSurface(bmp,0,pantalla,0);
    SDL_Surface* boton1 = IMG_Load("../imagenes/botones/Salir.png");
     if(!boton1)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Rect rectbtn;
    rectbtn.x=630;
    rectbtn.y=20;
    SDL_BlitSurface(boton1, 0, pantalla, &rectbtn);
    SDL_Surface* boton2 = IMG_Load("../imagenes/otros/suma.png");
     if(!boton2)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    rectbtn.x=290;
    rectbtn.y=500;
    SDL_BlitSurface(boton2, 0, pantalla, &rectbtn);
    SDL_Surface* boton3 = IMG_Load("../imagenes/otros/resta.png");
     if(!boton3)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    rectbtn.x=350;
    rectbtn.y=500;
    SDL_BlitSurface(boton3, 0, pantalla, &rectbtn);
    SDL_Surface* boton4 = IMG_Load("../imagenes/otros/producto.png");
     if(!boton4)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    rectbtn.x=410;
    rectbtn.y=500;
    SDL_BlitSurface(boton4, 0, pantalla, &rectbtn);
    SDL_Surface* boton5 = IMG_Load("../imagenes/otros/division.png");
     if(!boton5)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    rectbtn.x=470;
    rectbtn.y=500;
    SDL_BlitSurface(boton5, 0, pantalla, &rectbtn);
}

Uint32 calculo::generacuentaope(SDL_Surface* pantalla){
    Uint32 num1, num2, operador;
    int w,h;
    char cadena[30];
     //Cargamos los tipos de letras
    TTF_Font *fuente;
    fuente = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 40);
    if(!fuente)
    {
        cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
        exit(1);
    }
    //Cargamos el numero a recordar
    SDL_Surface *texto;
    SDL_Color color;
    SDL_Rect dest;
    // Establecemos el color para la fuente
    color.r = 0;
    color.g = 0;
    color.b = 0;

    num1=1+rand()%9;
    num2=2+rand()%8;
    operador=rand()%4;
    switch(operador){
        case 0: {
            sprintf(cadena,"%d  ?  %d  =  %d",num1,num2,num1+num2);
            TTF_SizeUTF8(fuente, cadena, &w, &h);
            texto = TTF_RenderText_Blended(fuente, cadena, color);
        }
        break;
        case 1:{
            sprintf(cadena,"%d  ?  %d  =  %d",num1,num2,num1-num2);
            TTF_SizeUTF8(fuente, cadena, &w, &h);
            texto = TTF_RenderText_Blended(fuente, cadena, color);
        }
        break;
        case 2:{
            sprintf(cadena,"%d  ?  %d  =  %d",num1,num2,num1*num2);
            TTF_SizeUTF8(fuente, cadena, &w, &h);
            texto = TTF_RenderText_Blended(fuente, cadena, color);
        }
        break;
        case 3:{
            while(num1%num2!=0)
                num2=1+rand()%9;
            cout<<"Num2: "<<num2<<endl;
            sprintf(cadena,"%d  ?  %d  =  %d",num1,num2, num1/num2);
            TTF_SizeUTF8(fuente, cadena, &w, &h);
            texto = TTF_RenderText_Blended(fuente, cadena, color);
        }
        break;
        default:
            cout<<"Operador Incorrecto"<<endl;
            exit(1);
    }
    dest.x=400-w/2;
    dest.y=300-h/2;
    SDL_BlitSurface(texto,0,pantalla,&dest);
    return operador+1;
}

Uint32 calculo::operadores(SDL_Surface* pantalla){
     bool done=false;
    Uint32 operador, nivel=1, tiempo;
    SDL_Rect recttiempo;
    recttiempo.x=700;
    recttiempo.y=550;
    recttiempo.h=50;
    recttiempo.w=100;
    reloj crono(90, 730, 555);
    dibujarescenarioope(pantalla);
    operador=generacuentaope(pantalla);
     while (!done)
    {
        // Manejo de eventos
        SDL_Event event;
        while(SDL_PollEvent(&event)){
        	//tecl.actualizar();
       		if(event.type==SDL_QUIT){
                    return 0;
       		 }
                if(event.type==SDL_MOUSEBUTTONDOWN)
                {
                    Uint32 mousex, mousey;
                    mousex=event.button.x;
                    mousey=event.button.y;
                    //Comprobacion btn modo arcade
                    if(mousex>630&&mousey>20&&mousex<(630+150)&&mousey<(20+40)){
                        cout<<"Pulsacion de boton: Salir"<<endl;
                        return 0;
                    }
                    if(mousex>290&&mousey>500&&mousex<(290+40)&&mousey<(500+40)){
                        cout<<"Pulsacion de boton: Suma"<<endl;
                        if(operador==1){
                            nivel++;
                            dibujarescenarioope(pantalla);
                            operador=generacuentaope(pantalla);
                            crono.dibujatiempo(pantalla);
                        }
                    }
                    if(mousex>350&&mousey>500&&mousex<(350+40)&&mousey<(500+40)){
                        cout<<"Pulsacion de boton: Resta"<<endl;
                        if(operador==2){
                            nivel++;
                            dibujarescenarioope(pantalla);
                            operador=generacuentaope(pantalla);
                            crono.dibujatiempo(pantalla);
                        }
                    }
                    if(mousex>410&&mousey>500&&mousex<(410+40)&&mousey<(500+40)){
                        cout<<"Pulsacion de boton: Producto"<<endl;
                        if(operador==3){
                            nivel++;
                            dibujarescenarioope(pantalla);
                            operador=generacuentaope(pantalla);
                            crono.dibujatiempo(pantalla);
                        }
                    }
                    if(mousex>470&&mousey>500&&mousex<(470+40)&&mousey<(500+40)){
                        cout<<"Pulsacion de boton: Division"<<endl;
                        if(operador==4){
                            nivel++;
                            dibujarescenarioope(pantalla);
                            operador=generacuentaope(pantalla);
                            crono.dibujatiempo(pantalla);
                        }
                    }

                }
                if(event.type==SDL_KEYDOWN)
                {
                    switch(event.key.keysym.sym){
                        case SDLK_KP_PLUS:{
                            if(operador==1){
                                nivel++;
                                dibujarescenarioope(pantalla);
                                operador=generacuentaope(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_KP_MINUS:{
                            if(operador==2){
                                nivel++;
                                dibujarescenarioope(pantalla);
                                operador=generacuentaope(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        case SDLK_KP_MULTIPLY:{
                            if(operador==3){
                                nivel++;
                                dibujarescenarioope(pantalla);
                                operador=generacuentaope(pantalla);

                            }
                        }
                        break;
                        case SDLK_KP_DIVIDE:{
                            if(operador==4){
                                nivel++;
                                dibujarescenarioope(pantalla);
                                operador=generacuentaope(pantalla);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                        break;
                        default:
                            cout<<"Tecla Incorrecta"<<endl;
                    }
                }
        }
        if(SDL_GetTicks()-tiempo>1000){
            SDL_FillRect(pantalla, &recttiempo, SDL_MapRGB(pantalla->format,162,162,160));
            crono.actualizartiempo(pantalla);
            tiempo=SDL_GetTicks();
        }
        if(crono.consultarseg()==0){
            done=true;
        }
        SDL_Flip(pantalla);
     }
    return nivel;
}
calculo::~calculo() {
}

