/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <iostream>
#include <cstdlib>
#include "logica.h"
#include "reloj.h"

using namespace std;

logica::logica() {
}

void logica::dibujarescenariolys(SDL_Surface* pantalla){
        //Cargamos la imagen de fondo
    SDL_Surface* bmp =IMG_Load("../imagenes/fondos/lucesysombras.png");
    if (!bmp)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_BlitSurface(bmp,0,pantalla,0);
    SDL_Surface* boton1 = IMG_Load("../imagenes/botones/Salir.png");
     if(!boton1)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Rect rectbtn;
    rectbtn.x=630;
    rectbtn.y=20;
    SDL_BlitSurface(boton1, 0, pantalla, &rectbtn);
    SDL_Surface* boton2 = IMG_Load("../imagenes/botones/Resetear.png");
     if(!boton2)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    rectbtn.x=630;
    rectbtn.y=80;
    SDL_BlitSurface(boton2, 0, pantalla, &rectbtn);
}

SDL_Surface* logica::cargartablero(Uint32 nivel, bool tablero[][5]){
    char ruta[30];
    SDL_Rect dest;
    SDL_Surface *pantallatablero=IMG_Load("../imagenes/fondos/lucesysombras_tabl.png");
    if(!pantallatablero)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Surface *luzen=IMG_Load("../imagenes/otros/luz_en.png");
    if(!luzen)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Surface *luzap=IMG_Load("../imagenes/otros/luz_ap.png");
    if(!luzap)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    Uint32 dato;
    sprintf(ruta,"maps/%d.map",nivel);
    FILE *f=fopen(ruta,"r");
    if(!f){
        cerr<<"Error de apertura de fichero de mapa"<<endl;
        exit(1);
    }
    dest.x=5;
    dest.y=5;
    for(Uint32 i=0;i<5;i++){
        for(Uint32 j=0;j<5;j++){
            fscanf(f,"%d",&dato);
            if(dato==0){
                tablero[i][j]=false;
                SDL_BlitSurface(luzap,0,pantallatablero,&dest);
            }
            else{
                tablero[i][j]=true;
                SDL_BlitSurface(luzen,0,pantallatablero,&dest);
            }
            
            dest.x+=85;
        }
        fscanf(f,"\n");
        dest.x=5;
        dest.y+=80;
    }
    return pantallatablero;
}

void logica::movimientolys(Uint32 y, Uint32 x, bool tablero[][5]){
    if(tablero[y][x]==true){     //Cambio de estado luz central
        tablero[y][x]=false;
    }
    else{
        tablero[y][x]=true;
    }
    if(x>0){     //Cambio de estado luz iquierda
        if(tablero[y][x-1]==true){
            tablero[y][x-1]=false;
        }
        else{
            tablero[y][x-1]=true;
        }
    }
    if(x<4){     //Cambio de estado luz derecha
        if(tablero[y][x+1]==true){
            tablero[y][x+1]=false;
        }
        else{
            tablero[y][x+1]=true;
        }
    }
    if(y>0){     //Cambio de estado luz arriba
        if(tablero[y-1][x]==true){
            tablero[y-1][x]=false;
        }
        else{
            tablero[y-1][x]=true;
        }
    }
    if(y<4){     //Cambio de estado luz abajo
        if(tablero[y+1][x]==true){
            tablero[y+1][x]=false;
        }
        else{
            tablero[y+1][x]=true;
        }
    }
}

void logica::dibujarmatrizlys(bool tablero[][5], SDL_Surface* pantallatablero){
    SDL_Rect dest;
    SDL_Surface *luzen=IMG_Load("../imagenes/otros/luz_en.png");
    if(!luzen)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Surface *luzap=IMG_Load("../imagenes/otros/luz_ap.png");
    if(!luzap)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    dest.x=5;
    dest.y=5;
    for(Uint32 i=0;i<5;i++){
        for(Uint32 j=0;j<5;j++){
            if(tablero[i][j]==false){
                SDL_BlitSurface(luzap,0,pantallatablero,&dest);
            }
            else
                SDL_BlitSurface(luzen,0,pantallatablero,&dest);
            dest.x+=85;
        }
        dest.x=5;
        dest.y+=80;
    }
}

bool logica::terminadolys(bool tablero[][5]){
    for(Uint32 i=0;i<5;i++){
        for(Uint32 j=0;j<5;j++){
            if(tablero[i][j]==true)
                return false;
        }
    }
    return true;
}

Uint32 logica::lucesysombras(Uint32 nivelinicial, bool arcade, SDL_Surface* pantalla){
    bool done=false, terminado=false;
    bool tablero[5][5];
    Uint32 nivel=nivelinicial, tiempo=0, min, seg;
    SDL_Rect dest,trozo, trozotiempo;
    dest.x=187;
    dest.y=150;
    SDL_Surface *pantallatablero;
    trozo.x=700;
    trozo.y=530;
    trozo.h=50;
    trozo.w=80;
    trozotiempo.x=700;
    trozotiempo.y=530;
    SDL_Surface* bmp = IMG_Load("../imagenes/fondos/lucesysombras.png");
    if (!bmp)
    {
        cerr<<"Imposible cargar bitmap: "<< SDL_GetError()<<endl;
        exit(1);
    }
    reloj crono(730,555);
    dibujarescenariolys(pantalla);
    pantallatablero=cargartablero(nivel,tablero);
    SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
     while (!done)
    {
        // Manejo de eventos
        SDL_Event event;
        while(SDL_PollEvent(&event)){
        	//tecl.actualizar();
       		if(event.type==SDL_QUIT){
                    return 0;
       		 }
                if(event.type==SDL_MOUSEBUTTONDOWN)
                {
                    Uint32 mousex, mousey;
                    mousex=event.button.x;
                    mousey=event.button.y;
                    //Comprobacion btn modo arcade
                    if(mousex>630&&mousey>20&&mousex<(630+150)&&mousey<(20+40)){
                        cout<<"Pulsacion de boton: Salir"<<endl;
                        return 0;
                    }
                    if(mousex>630&&mousey>80&&mousex<(630+150)&&mousey<(80+40)){
                        cout<<"Pulsacion de boton: Resetear"<<endl;
                        pantallatablero=cargartablero(nivel,tablero);
                        SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                    }
                    if(mousex>192&&mousey>155&&mousex<(192+77)&&mousey<(155+71)){
                        movimientolys(0,0,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>277&&mousey>155&&mousex<(277+77)&&mousey<(155+71)){
                        movimientolys(0,1,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>362&&mousey>155&&mousex<(362+77)&&mousey<(155+71)){
                        movimientolys(0,2,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>447&&mousey>155&&mousex<(447+77)&&mousey<(155+71)){
                        movimientolys(0,3,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>532&&mousey>155&&mousex<(532+77)&&mousey<(155+71)){
                        movimientolys(0,4,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>192&&mousey>235&&mousex<(192+77)&&mousey<(235+71)){
                        movimientolys(1,0,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>277&&mousey>235&&mousex<(277+77)&&mousey<(235+71)){
                        movimientolys(1,1,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>362&&mousey>235&&mousex<(362+77)&&mousey<(235+71)){
                        movimientolys(1,2,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>447&&mousey>235&&mousex<(447+77)&&mousey<(235+71)){
                        movimientolys(1,3,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>532&&mousey>235&&mousex<(532+77)&&mousey<(235+71)){
                        movimientolys(1,4,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>192&&mousey>315&&mousex<(192+77)&&mousey<(315+71)){
                        movimientolys(2,0,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>277&&mousey>315&&mousex<(277+77)&&mousey<(315+71)){
                        movimientolys(2,1,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>362&&mousey>315&&mousex<(362+77)&&mousey<(315+71)){
                        movimientolys(2,2,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>447&&mousey>315&&mousex<(447+77)&&mousey<(315+71)){
                        movimientolys(2,3,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>532&&mousey>315&&mousex<(532+77)&&mousey<(315+71)){
                        movimientolys(2,4,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>192&&mousey>395&&mousex<(192+77)&&mousey<(395+71)){
                        movimientolys(3,0,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>277&&mousey>395&&mousex<(277+77)&&mousey<(395+71)){
                        movimientolys(3,1,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>362&&mousey>395&&mousex<(362+77)&&mousey<(395+71)){
                        movimientolys(3,2,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>447&&mousey>395&&mousex<(447+77)&&mousey<(395+71)){
                        movimientolys(3,3,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>532&&mousey>395&&mousex<(532+77)&&mousey<(395+71)){
                        movimientolys(3,4,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>192&&mousey>475&&mousex<(192+77)&&mousey<(475+71)){
                        movimientolys(4,0,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>277&&mousey>475&&mousex<(277+77)&&mousey<(475+71)){
                        movimientolys(4,1,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>362&&mousey>475&&mousex<(362+77)&&mousey<(475+71)){
                        movimientolys(4,2,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>447&&mousey>475&&mousex<(447+77)&&mousey<(475+71)){
                        movimientolys(4,3,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                    if(mousex>532&&mousey>475&&mousex<(532+77)&&mousey<(475+71)){
                        movimientolys(4,4,tablero);
                        if(!terminadolys(tablero)){
                            dibujarmatrizlys(tablero,pantallatablero);
                            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
                        }
                        else
                            terminado=true;
                    }
                }
        }
        if(terminado==true){
            terminado=false;
            //Dibujamos aunque el escenario este vacío
            dibujarmatrizlys(tablero,pantallatablero);
            SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
            SDL_Flip(pantalla);
            SDL_Delay(1000);
            if(nivel!=4&&arcade!=true){
                nivel++;
                pantallatablero=cargartablero(nivel,tablero);
                SDL_BlitSurface(pantallatablero,0,pantalla,&dest);
            }
            else{
                crono.consultartiempo(&min,&seg);
                return seg+min*60;
            }
        }
        if(SDL_GetTicks()-tiempo>1000){
            SDL_BlitSurface(bmp,&trozo,pantalla,&trozotiempo);
            crono.actualizartiempo(pantalla);
            tiempo=SDL_GetTicks();
        }
        SDL_Flip(pantalla);
     }
    return 0;
}

logica::~logica() {
}

