/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/


#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <iostream>
#include "memoria.h"
#include "reloj.h"

using namespace std;

memoria::memoria() {
    srand(time(0));
}

void memoria::dibujaescenarioacuerdate(SDL_Surface* pantalla){
    SDL_Surface* fondo = IMG_Load("../imagenes/fondos/acuerdatedemi.png");
     if(!fondo)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_BlitSurface(fondo, 0, pantalla, 0);
     SDL_Surface* boton1 = IMG_Load("../imagenes/botones/Salir.png");
     if(!boton1)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Rect rectbtn;
    rectbtn.x=630;
    rectbtn.y=20;
    SDL_BlitSurface(boton1, 0, pantalla, &rectbtn);
}

void memoria::dibujapersonajesacuerdate(SDL_Surface* pantalla, Uint32 matriz[][4]){
    char ruta[30];
    Uint32 numero;
    SDL_Rect rectfig;
    SDL_Surface *fig;
    rectfig.x=170;
    rectfig.y=200;
    for(Uint32 i=0;i<3;i++){
        for(Uint32 j=0;j<4;j++){
            numero=1+rand()%11;
            sprintf(ruta,"../imagenes/sprites/%d.bmp",numero);
            fig=IMG_Load(ruta);
            if(!fig){
                cerr<<"Imposible cargar bitmap: "<< SDL_GetError()<<endl;
                exit(1);
            }
            matriz[i][j]=numero;
            rectfig.x+=75;
            SDL_BlitSurface(fig, 0, pantalla, &rectfig);

        }
        rectfig.y+=82;
        rectfig.x=170;
    }
}

void memoria::borrapersonajesacuerdate(SDL_Surface* pantalla, Uint32 nivel, Uint32 matriz[][4]){
    Uint32 aleatoriox, aleatorioy;
    bool ocurrencias[3][4];
    int w, h;
    char ruta[30];
    SDL_Surface* fig;
    SDL_Rect rectfig;
    rectfig.x=170;
    rectfig.y=200;
    for(Uint32 i=0;i<3;i++)
        for(Uint32 j=0;j<4;j++)
            ocurrencias[i][j]=false;
    dibujaescenarioacuerdate(pantalla);
    for(Uint32 i=0;i<nivel;i++)
    {
        //Para saber cuales son los que ocultamos sumamos al valor de la matriz 30
        aleatoriox=rand()%4;
        aleatorioy=rand()%3;
        //Comprobar que no ocultamos dos veces un personaje en la misma posicion
        while(ocurrencias[aleatoriox][aleatorioy]==true){
            aleatoriox=rand()%4;
            aleatorioy=rand()%3;
        }
        ocurrencias[aleatoriox][aleatorioy]=true;
        matriz[aleatoriox][aleatorioy]+=30;
    }
        for(Uint32 k=0;k<3;k++){
            for(Uint32 j=0;j<4;j++){
                if(matriz[k][j]>20){        //Si es mayor que veinte es porque le hemos sumado 30 y es un personaje oculto
                    rectfig.x+=75;      //Lo pasamos de largo
                }
                else{
                    sprintf(ruta,"../imagenes/sprites/%d.bmp",matriz[k][j]);
                    fig=IMG_Load(ruta);
                    if(!fig){
                        cerr<<"Imposible cargar bitmap: "<< SDL_GetError()<<endl;
                        exit(1);
                    }
                    rectfig.x+=75;
                    SDL_BlitSurface(fig, 0, pantalla, &rectfig);
                }
            }
            rectfig.y+=82;
            rectfig.x=170;
        }
    rectfig.x=4;
    rectfig.y=520;
    //Imprimimos todos los sprites para que el usuario elija el que desapareció
    for(Uint32 i=1;i<13;i++){
        sprintf(ruta,"../imagenes/sprites/%d.bmp",i);
        fig=IMG_Load(ruta);
        if(!fig){
            cerr<<"Imposible cargar bitmap: "<< SDL_GetError()<<endl;
            exit(1);
        }
        
        SDL_BlitSurface(fig, 0, pantalla, &rectfig);
        rectfig.x+=66;
    }
    //Imprimimos el mensaje
    TTF_Font *fuente;
    fuente = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 25);
    if(!fuente)
    {
        cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Surface *texto;
    SDL_Color color;
    // Establecemos el color para la fuente
    color.r = 255;
    color.g = 255;
    color.b = 255;
    TTF_SizeUTF8(fuente, "Indica los que faltan", &w, &h);
    texto = TTF_RenderText_Blended(fuente, "Indica los que faltan", color);
    SDL_Rect dest;
    dest.x=400-w/2;
    dest.y=480;
    SDL_BlitSurface(texto, 0, pantalla, &dest);
}

bool memoria::comprobarpersonajesacuerdate(SDL_Surface* pantalla, Uint32 matriz[][4], Uint32 personaje){
    SDL_Rect dest;
    char ruta[30];
    SDL_Surface* fig;
    for(Uint32 i=0;i<3;i++){
        for(Uint32 j=0;j<4;j++){
            if(matriz[i][j]==personaje+30){
                cout<<"Correcto"<<endl;
                matriz[i][j]-=30;
                dest.x=245+j*75;
                dest.y=200+i*82;
                sprintf(ruta,"../imagenes/sprites/%d.bmp",personaje);
                fig=IMG_Load(ruta);
                if(!fig){
                    cerr<<"Imposible cargar bitmap: "<< SDL_GetError()<<endl;
                    exit(1);
                }
                SDL_BlitSurface(fig, 0, pantalla, &dest);
                return true;
            }
        }
    }
    return false;
}

void memoria::imprimirfallosacuerdate(SDL_Surface* pantalla, Uint32 numfallos){
    char cadena[30];
    int w, h;
    TTF_Font *fuente;
    fuente = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 20);
    if(!fuente)
    {
        cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
        exit(1);
    }
    //Cargamos el numero a recordar
    SDL_Surface *texto;
    SDL_Color color;
    // Establecemos el color para la fuente
    color.r = 255;
    color.g = 255;
    color.b = 255;
    sprintf(cadena,"Fallos Restantes: %d",numfallos);
    TTF_SizeUTF8(fuente, cadena, &w, &h);
    texto = TTF_RenderText_Blended(fuente, cadena, color);
    SDL_Rect dest, trozo;
    dest.x=30;
    dest.y=410;
    trozo.x=30;
    trozo.y=410;
    trozo.w=w;
    trozo.h=h;
    SDL_Surface* fondo = IMG_Load("../imagenes/fondos/acuerdatedemi.png");
     if(!fondo)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_BlitSurface(fondo, &trozo, pantalla, &dest);
    SDL_BlitSurface(texto, 0, pantalla, &dest);
}
Uint32 memoria::acuerdatedemi(SDL_Surface* pantalla)
{
    SDL_Rect recttiempo;
    Uint32 matriz[3][4];
    Uint32 tiempo=0, nivel=1, numpersonajes=nivel,tiemponivel=7, numfallos=2;
    bool done=false, completadotiempo=false;
    recttiempo.x=700;
    recttiempo.y=550;
    recttiempo.h=40;
    recttiempo.w=80;
    reloj crono(tiemponivel,730,555);
    dibujaescenarioacuerdate(pantalla);
    dibujapersonajesacuerdate(pantalla, matriz);
    imprimirfallosacuerdate(pantalla, numfallos);
    while (!done)
    {
        // Manejo de eventos
        SDL_Event event;
        while(SDL_PollEvent(&event)){
       		if(event.type==SDL_QUIT){
        		done=true;
        		break;
       		 }
                if(event.type==SDL_MOUSEBUTTONDOWN)
                {
                    Uint32 mousex, mousey;
                    mousex=event.button.x;
                    mousey=event.button.y;
                    if(mousex>630&&mousey>20&&mousex<(630+150)&&mousey<(20+40)){
                        cout<<"Pulsacion de boton: Salir"<<endl;
                        done=true;
                    }
                    if(mousex>4&&mousey>520&&mousex<(4+65)&&mousey<(520+72)&&completadotiempo){
                        if(comprobarpersonajesacuerdate(pantalla, matriz, 1)){
                            numpersonajes--;
                        }
                        else{
                            if(numfallos!=0){
                                numfallos--;
                                imprimirfallosacuerdate(pantalla, numfallos);
                            }
                            else{
                                done=true;
                            }
                        }
                    }
                    if(mousex>70&&mousey>520&&mousex<(70+65)&&mousey<(520+72)&&completadotiempo){
                        if(comprobarpersonajesacuerdate(pantalla, matriz, 2)){
                            numpersonajes--;
                        }
                        else{
                            if(numfallos!=0){
                                numfallos--;
                                imprimirfallosacuerdate(pantalla, numfallos);
                            }
                            else{
                                done=true;
                            }
                        }
                    }
                    if(mousex>136&&mousey>520&&mousex<(136+65)&&mousey<(520+72)&&completadotiempo){
                        if(comprobarpersonajesacuerdate(pantalla, matriz, 3)){
                            numpersonajes--;
                        }
                        else{
                            if(numfallos!=0){
                                numfallos--;
                                imprimirfallosacuerdate(pantalla, numfallos);
                            }
                            else{
                                done=true;
                            }
                        }
                    }
                    if(mousex>202&&mousey>520&&mousex<(202+65)&&mousey<(520+72)&&completadotiempo){
                        if(comprobarpersonajesacuerdate(pantalla, matriz, 4)){
                            numpersonajes--;
                        }
                        else{
                            if(numfallos!=0){
                                numfallos--;
                                imprimirfallosacuerdate(pantalla, numfallos);
                            }
                            else{
                                done=true;
                            }
                        }
                    }
                    if(mousex>268&&mousey>520&&mousex<(268+65)&&mousey<(520+72)&&completadotiempo){
                        if(comprobarpersonajesacuerdate(pantalla, matriz, 5)){
                            numpersonajes--;
                        }
                        else{
                            if(numfallos!=0){
                                numfallos--;
                                imprimirfallosacuerdate(pantalla, numfallos);
                            }
                            else{
                                done=true;
                            }
                        }
                    }
                    if(mousex>334&&mousey>520&&mousex<(334+65)&&mousey<(520+72)&&completadotiempo){
                        if(comprobarpersonajesacuerdate(pantalla, matriz, 6)){
                            numpersonajes--;
                        }
                        else{
                            if(numfallos!=0){
                                numfallos--;
                                imprimirfallosacuerdate(pantalla, numfallos);
                            }
                            else{
                                done=true;
                            }
                        }
                    }
                    if(mousex>400&&mousey>520&&mousex<(400+65)&&mousey<(520+72)&&completadotiempo){
                        if(comprobarpersonajesacuerdate(pantalla, matriz, 7)){
                            numpersonajes--;
                        }
                        else{
                            if(numfallos!=0){
                                numfallos--;
                                imprimirfallosacuerdate(pantalla, numfallos);
                            }
                            else{
                                done=true;
                            }
                        }
                    }
                    if(mousex>466&&mousey>520&&mousex<(466+65)&&mousey<(520+72)&&completadotiempo){
                        if(comprobarpersonajesacuerdate(pantalla, matriz, 8)){
                            numpersonajes--;
                        }
                        else{
                            if(numfallos!=0){
                                numfallos--;
                                imprimirfallosacuerdate(pantalla, numfallos);
                            }
                            else{
                                done=true;
                            }
                        }
                    }
                    if(mousex>532&&mousey>520&&mousex<(532+65)&&mousey<(520+72)&&completadotiempo){
                        if(comprobarpersonajesacuerdate(pantalla, matriz, 9)){
                            numpersonajes--;
                        }
                        else{
                            if(numfallos!=0){
                                numfallos--;
                                imprimirfallosacuerdate(pantalla, numfallos);
                            }
                            else{
                                done=true;
                            }
                        }
                    }
                    if(mousex>598&&mousey>520&&mousex<(598+65)&&mousey<(520+72)&&completadotiempo){
                        if(comprobarpersonajesacuerdate(pantalla, matriz, 10)){
                            numpersonajes--;
                        }
                        else{
                            if(numfallos!=0){
                                numfallos--;
                                imprimirfallosacuerdate(pantalla, numfallos);
                            }
                            else{
                                done=true;
                            }
                        }
                    }
                    if(mousex>664&&mousey>520&&mousex<(664+65)&&mousey<(520+72)&&completadotiempo){
                        if(comprobarpersonajesacuerdate(pantalla, matriz, 11)){
                            numpersonajes--;
                        }
                        else{
                            if(numfallos!=0){
                                numfallos--;
                                imprimirfallosacuerdate(pantalla, numfallos);
                            }
                            else{
                                done=true;
                            }
                        }
                    }
                    if(mousex>730&&mousey>520&&mousex<(730+65)&&mousey<(520+72)&&completadotiempo){
                        if(comprobarpersonajesacuerdate(pantalla, matriz, 12)){
                            numpersonajes--;
                        }
                        else{
                            if(numfallos!=0){
                                numfallos--;
                                imprimirfallosacuerdate(pantalla, numfallos);
                            }
                            else{
                                done=true;
                            }
                        }
                    }
                }
        }
        if(SDL_GetTicks()-tiempo>1000&&!completadotiempo){
            if(crono.consultarseg()==0){   //Si se acaba el tiempo
                //Funcion que elimina un personaje
                cout<<"Completado el tiempo"<<endl;
                completadotiempo=true;
                borrapersonajesacuerdate(pantalla, nivel, matriz);
                imprimirfallosacuerdate(pantalla, numfallos);
            }
            else{
                SDL_FillRect(pantalla, &recttiempo, SDL_MapRGB(pantalla->format,0,0,0));
                crono.actualizartiempo(pantalla);
                tiempo=SDL_GetTicks();
            }
        }
        if(numpersonajes==0){
            cout<<"Completado"<<endl;
            nivel++;
            numpersonajes=nivel;
            tiemponivel++;
            completadotiempo=false;
            dibujaescenarioacuerdate(pantalla);
            dibujapersonajesacuerdate(pantalla, matriz);
            imprimirfallosacuerdate(pantalla, numfallos);
            crono.settime(0,tiemponivel);
            tiempo=SDL_GetTicks();
        }
        SDL_Flip(pantalla);
        
    }
    return nivel-1;
}

memoria::~memoria() {
}

