/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#ifndef _MEMORIA_H
#define	_MEMORIA_H
/** Clase memoria
 * Donde agruparemos todos los juegos referentes a esta clase de juegos
 */
class memoria {
public:
    /**Constructor de la clase memoria*/
    memoria();
    /** Juego acuerdatede mi nos devuelve el el nivel que hemos alcanzado
     * @param pantalla recibe la variable pantalla para poder imprimir los gráficos
     */
    Uint32 acuerdatedemi(SDL_Surface* pantalla);
    virtual ~memoria();
private:
    /** @brief Funcion para dibujar el escenario vacio
     * Con esta funcion conseguiremos limpiar la pantalla y dejarla solamente con la imagen de fondo
     * y con los botones de salir
     * @param pantalla recibe la variable pantalla para poder modificar los gráficos de la pantalla
     */
    void dibujaescenarioacuerdate(SDL_Surface* pantalla);
    /** @brief Funcion que dibuja los personajes a memorizar
     * Con esta funcion aleatoriamente imprimira una serie de personajes para que el usuario los
     * pueda memorizar
     * @param pantalla recibe la variable pantalla para poder modificar los gráficos de la pantalla
     * @param matriz recibe una matriz en el que almacenará los personajes que se han incluido en la pantalla en forma de enteros
     */
    void dibujapersonajesacuerdate(SDL_Surface* pantalla, Uint32 matriz[][4]);

     void borrapersonajesacuerdate(SDL_Surface* pantalla, Uint32 nivel, Uint32 matriz[][4]);

     bool comprobarpersonajesacuerdate(SDL_Surface* pantalla, Uint32 matriz[][4], Uint32 personaje);

     void imprimirfallosacuerdate(SDL_Surface* pantalla, Uint32 numfallos);
};

#endif	/* _MEMORIA_H */

