/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#include <iostream>
//#include <SDL/SDL.h>
#include "musica.h"

using namespace std;

Musica::Musica(const char* ruta)
{
    m=Mix_LoadMUS(ruta);
    if(m==NULL)
    {
        cerr<<"Imposible abrir el archivo de audio: "<<SDL_GetError()<<endl;
        exit(1);
    }
    //Establecemos el volumen
    Mix_VolumeMusic(VOLUMEN);
    
}

void Musica::Reproducir()
{
    Mix_PlayMusic(m,-1);
}

void Musica::Pausar()
{
    Mix_PauseMusic();
}

Musica::~Musica(){
    //Mix_FreeMusic(m);
}
