/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#ifndef _MUSICA_H
#define	_MUSICA_H
#include <SDL/SDL_mixer.h>
/**Constante en la que almacenaremos el volumen del sonido de fondo*/
#define VOLUMEN 80
/**Clase Musica: Es la clase encargada de cargar, reproducir y pausar los sonidos*/
class Musica{
public:
    /**Constructor de la clase musica que recibe como parámetro la ruta donde
     *se encuentra el ficher de audio, los formatos que soporta son principalmente
     *mp3, wav, ogg y alguno más ver documentacion de SDL_mixer*/
    Musica(const char* ruta);
    /**Reproduce el sonido ya cargado*/
    void Reproducir();
    /**Pausa el sonido ya cargado*/
    void Pausar();
    /**Destructor de la clase musica*/
    virtual ~Musica();
private:
    Mix_Music *m;
};
#endif

