/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/


#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <iostream>

#include "reloj.h"

using namespace std;

reloj::reloj(Uint32 posx, Uint32 posy){
    _posx=posx;
    _posy=posy;
    minutos=0;
    segundos=0;
    fuente = TTF_OpenFont("../fuentes/FreeSans.ttf", 20);
    if(!fuente)
    {
        cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
        exit(1);
    }
    cronometro=false;
}

reloj::reloj(Uint32 tiempo, Uint32 posx, Uint32 posy){
    _posx=posx;
    _posy=posy;
    minutos=tiempo/60;
    segundos=tiempo%60;
    fuente=TTF_OpenFont("../fuentes/FreeSans.ttf", 30);
    if(!fuente)
    {
        cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
        exit(1);
    }
    cronometro=true;
}

void reloj::actualizartiempo(SDL_Surface* pantalla){
    if(cronometro==false){
        if(segundos<59)
            segundos++;
        else{
            segundos=0;
            minutos++;
        }
    }
    else{
        if(segundos==0){
            minutos--;
            segundos=59;
        }
        else{
            segundos--;
        }
    }
     dibujatiempo(pantalla);
}

void reloj::dibujatiempo(SDL_Surface* pantalla){
    char cadena[40]; //Cadena con el numero generado automaticamente
    int w=20;
    //Cargamos el numero a recordar
    
    SDL_Color color;
    // Establecemos el color para la fuente
    color.r = 255;
    color.g = 255;
    color.b = 255;
    sprintf(cadena,"%d:%d",minutos, segundos);
    //TTF_SizeUTF8(fuente, cadena, &w, &h);
    texto = TTF_RenderText_Blended(fuente, cadena, color);
    SDL_Rect dest;

    //Centramos horizontalmente el texto
    dest.x = _posx-(w/2);
    dest.y = _posy;
    SDL_BlitSurface(texto, 0, pantalla, &dest);
}

void reloj::consultartiempo(Uint32* min, Uint32* seg){
    *min=minutos;
    *seg=segundos;
}

Uint32 reloj::consultarseg(){
    return minutos*60+segundos;
}
void reloj::settime(Uint32 min, Uint32 seg){
    minutos=min;
    segundos=seg;
    cronometro=true;
}

reloj::~reloj() {
}

